package com.casic.dcms.mvp.model;

import com.casic.dcms.bean.EventSourceBean;
import com.casic.dcms.utils.retrofit.RetrofitServiceManager;

import rx.Observable;
import rx.Observer;
import rx.Subscription;
import rx.android.schedulers.AndroidSchedulers;
import rx.schedulers.Schedulers;

/**
 * @author : Pengxh
 * @time : 2021/4/16 9:53
 * @email : 290677893@qq.com
 **/
public class EventSourceModelImpl implements IEventSourceModel {

    private OnGetEventSourceListener listener;

    public EventSourceModelImpl(OnGetEventSourceListener sourceListener) {
        this.listener = sourceListener;
    }

    /**
     * 数据回调接口
     */
    public interface OnGetEventSourceListener {
        void onSuccess(EventSourceBean resultBean);

        void onFailure(Throwable throwable);
    }

    @Override
    public Subscription sendRetrofitRequest(String begTime, String endTime) {
        Observable<EventSourceBean> observable = RetrofitServiceManager.getEventSourceResult(begTime, endTime);
        return observable.subscribeOn(Schedulers.io()).observeOn(AndroidSchedulers.mainThread()).subscribe(new Observer<EventSourceBean>() {
            @Override
            public void onCompleted() {

            }

            @Override
            public void onError(Throwable e) {
                if (e.getCause() != null) {
                    listener.onFailure(e);
                }
            }

            @Override
            public void onNext(EventSourceBean resultBean) {
                if (resultBean != null) {
                    listener.onSuccess(resultBean);
                }
            }
        });
    }
}
